### Ethernet server simulator (UDP w/o select) ###
#
# Public domain software
# (When using Python 2, part of this program must be commented/uncommented)
#
# Coded by Yasusi Kanada
# 2014-6-25; 2015-5-10

import optparse, socketserver, time, socket
from ether import SMAC, DMAC, printPacket

sendPacketStringPart = None

host = socket.gethostbyname(socket.gethostname())


class EthernetServer(socketserver.BaseRequestHandler):

    ### Packet handler ###

    def handle(self):
        packet = self.request[0]
        socket = self.request[1]
        dmac = DMAC(packet)
        smac = SMAC(packet)
        if dmac == opts.lmac:
            now = time.time()
            printPacket(packet, now, "Received:")

            sendPacket = bytes(smac + sendPacketStringPart, 'utf-8')  # !! Python 3 !!
            # sendPacket = smac + sendPacketStringPart		      # !! Python 2 !!
            sendBytes = socket.sendto(sendPacket, self.client_address)
            printPacket(sendPacket, now, "Sent:    ")

if __name__ == "__main__":
    # Parse command line
    parser = optparse.OptionParser()
    parser.add_option("--lp", "--lport", "--localPort", dest = "lport", type="int",
                      help = "Local network port id")
    parser.add_option("--rp", "--rport", "--remotePort", dest = "rport", type="int",
                      help = "Remote (next) network port id")
    parser.add_option("--lm", "--lmac", "--localMAC", dest = "lmac", type = "str",
                      help = "Local (my) MAC address")
    parser.set_defaults(lport = 4000, rport = 5000, lmac = "000000000000")
    opts, args = parser.parse_args()

    # Contents of packet to send (constant)
    sendPacketStringPart = opts.lmac + "0800" + "0f0e0d0c0b0a09080706050403020100"

    server = socketserver.UDPServer((host, opts.lport), EthernetServer)
    server.serve_forever()
